module Disloku
	module Util

		if (File::ALT_SEPARATOR.nil?)
			SPLIT_EXP = "\\#{File::SEPARATOR}"
		else
			SPLIT_EXP = "\\#{File::SEPARATOR}|\\#{File::ALT_SEPARATOR}"
		end

		class File

			def self.getSegments(path)
				return path.split(/#{SPLIT_EXP}/)
			end

			attr_accessor :srcPath, :change

			def initialize(filePath, basePath, target, change)
				@srcPath = filePath
				@target = target
				@change = change

				fileSegments = File.getSegments(filePath)
				baseSegments = File.getSegments(basePath)
				index = 0
				while (fileSegments[index] == baseSegments[index])
					index += 1
				end

				@relativeSrcSegments = fileSegments[index..-1]
				@relativeDstSegments = target.mapPath(@relativeSrcSegments)
			end

			def getRelativeDstSegments()
				return @segments
			end

			def getRelativeDirSegments()
				return @segments[0..-2]
			end

			def hasMapping?()
				return @relativeDstSegments != nil
			end

			def getAbsoluteDstPath(basePath = nil)
				basePath = basePath || @target.targetDir
				return ::File.join(basePath, *@relativeDstSegments)
			end

			def to_s()
				operation = (@change.changeType == :deleted ? "x>" : "->")
				return "#{srcPath} #{operation} #{getAbsoluteDstPath()}"
			end
		end
	end
end
